// naumann@stce.rwth-aachen.de

#include "list.hpp"

#include <iostream>
#include <cmath>

int main(int argc, char* argv[]) {
  using namespace std;
  if (argc!=4) throw runtime_error("main: argc!=4");
  try { // ensures proper cleanup in case of error
    list<float> l(stoi(argv[1]));  
    for (int i=0;i<l.length();i++) l.set(i,cos(i));  
    l.to_dot("1.dot");
    l.insert(stoi(argv[2]),42);  
    l.to_dot("2.dot");
    l.erase(stoi(argv[3]));  
    l.to_dot("3.dot");
  } catch (const runtime_error &e) {
    cerr << "ERROR: " << e.what() << endl;
  }
  return 0;
}
