// naumann@stce.rwth-aachen.de

#include "list.hpp"

#include <iostream>
#include <cmath>

int main(int argc, char* argv[]) {
  if (argc!=4) throw std::runtime_error("main: argc!=4");
  try { // proper cleanup in case of error
    list<float> l(std::stoi(argv[1]));  
    for (int i=0;i<l.length();i++) l.set(i,cos(i));  
    l.to_dot("1.dot");
    l.insert(std::stoi(argv[2]),42);  
    l.to_dot("2.dot");
    l.erase(std::stoi(argv[3]));  
    l.to_dot("3.dot");
    l.algorithms();
  } catch (const std::runtime_error &e) {
    std::cerr << "ERROR: " << e.what() << std::endl;
  }
  return 0;
}
