#include <iostream>

template<typename T>
vector<T>::vector(size_t n, const T &d) : v(new T[n]), n(n) {
  for (size_t i=0;i<n;i++) v[i]=d;
}

template<typename T>
vector<T>::~vector() { delete [] v; }

template<typename T>
void vector<T>::grow() {
  T* d=new T[n+1];
  for (size_t i=0;i<n;i++) d[i]=v[i];
  delete [] v;
  v=d;
  n++;
}

template<typename T>
void vector<T>::shrink() {
  T* d=new T[n-1];
  for (size_t i=0;i<n-1;i++) d[i]=v[i];
  delete [] v;
  v=d;
  n--;
}

template<typename T>
void vector<T>::insert(const T &d, size_t pos) {
  if (pos>=n) throw std::runtime_error("insert: out of range");
  else {
    grow();
    for (size_t i=n-1;i>pos;i--) v[i]=v[i-1];
    v[pos]=d;
  }
}

template<typename T>
void vector<T>::erase(size_t pos) {
  if (pos>=n) throw std::runtime_error("erase: out of range");
  else {
    for (size_t i=pos;i<n-1;i++) v[i]=v[i+1];
    shrink();
  }
}

template<typename T>
void vector<T>::print() const {
  std::cout << "[ ";
  for (size_t i=0;i<n;i++) 
    std::cout << v[i] << " ";
  std::cout << "]" << std::endl;
}
