// naumann@stce.rwth-aachen.de

#include "vector.hpp"

#include <iostream>

int main(int argc, char* argv[]) {
  if (argc!=2) throw "argc!=2";
  int n=std::stoi(argv[1]); 
  if (n<0) throw "n<0";
  try {
    vector<int> v(n,1); 
    try {
      for (int i=0;i<n;i++) v.insert(i,i);
      v.print();
      for (int i=0;i<n;i++) v.erase(n);
      v.print();
    } catch (const std::runtime_error &e) {
      std::cerr << e.what() << std::endl;
    }
  } catch (const std::bad_alloc &e) {
    std::cerr << e.what() << std::endl;
  }
  return 0;
}
